﻿namespace Engine_silk.NET
{
	public static class ArrayExtensions
	{
		/// <summary>
		/// Copies the given arrays to the start of this array. The order of <paramref name="arrays"/> is preserved
		/// </summary>
		/// <param name="arrays">The arrays copied into this array</param>
		public static void CopyFrom(this Array array, params Array[] arrays)
		{
			int lastIndex = 0;
			for (int i = 0; i < arrays.Length; i++)
			{
				arrays[i].CopyTo(array, lastIndex);
				lastIndex += arrays[i].Length;
			}
		}
	}
}
