﻿using Nebulix.Rendering;
using Silk.NET.Maths;
using Silk.NET.OpenGL;

namespace Engine_silk.NET
{
	// TODO: Think about just creating a cube with a certain resolution and then use this cube to generate the Sphere.
	// also maybe make an ISphere and call this class "CubeSphere"?
	public class Sphere(GL gl, float radius, uint resolution)
	{
		public void CreateSphere()
		{
			uint _vao, _vbo, _ebo;

			_vao = gl.CreateVertexArray();
			gl.BindVertexArray(_vao);

			ReadOnlySpan<float> verticesData = GetVertices();

			_vbo = gl.GenBuffer();
			gl.BindBuffer(BufferTargetARB.ArrayBuffer, _vbo);
			gl.BufferData(BufferTargetARB.ArrayBuffer, (nuint)(verticesData.Length * sizeof(float)), verticesData, BufferUsageARB.StaticDraw);

		}

		public void RenderSphere()
		{

		}

		// TODO: make this private after testing
		public ReadOnlySpan<float> GetVertices()
		{
			var front = GetSide(Vector3D<float>.UnitZ).Item1;
			var back = GetSide(-Vector3D<float>.UnitZ).Item1;
			var up = GetSide(Vector3D<float>.UnitY).Item1;
			var down = GetSide(-Vector3D<float>.UnitY).Item1;
			var left = GetSide(Vector3D<float>.UnitX).Item1;
			var right = GetSide(-Vector3D<float>.UnitX).Item1;

			var finalArray = new float[front.Length + back.Length + up.Length + down.Length + left.Length + right.Length];
			finalArray.CopyFrom(front, back, up, down, left, right);

			return new ReadOnlySpan<float>(finalArray);
		}


		[Obsolete("Use Sphere.GetFace(Vector3D<float>) instead")]
		private (float[], float[]) GetSide(Vector3D<float> localUp)
		{

			float stepSize = 2f / resolution;

			List<float> vertices = new((int)(3 * resolution * resolution * 2)); // resolution * resolution == number of rows/columns; 3 * ... == each vertex has 3 positions; 2 * ... == vertex also needs normal

			Vector3D<float> position = localUp;
			for (uint y = 0; y <= resolution; y++)
			{
				for (uint x = 0; x <= resolution; x++)
				{
					uint i = x + y * resolution;
					Vector2D<float> percent = new Vector2D<float>(x, y) / (resolution - 1);
					//Vector3D<float> pointOnUnitCube = localUp + (percent.X - 0.5f) * stepSize * 

					if (localUp.X != 0)
					{
						position.Y = x * stepSize - 1;
						position.Z = y * stepSize - 1;
					}
					else if (localUp.Y != 0)
					{
						position.X = x * stepSize - 1;
						position.Z = y * stepSize - 1;
					}
					else if (localUp.Z != 0)
					{
						position.X = x * stepSize - 1;
						position.Y = y * stepSize - 1;
					}
                    vertices.AddRange([position.X, position.Y, position.Z, localUp.X, localUp.Y, localUp.Z]);
				}
			}

			List<uint> indices = new((int)(resolution * resolution * 6)); // ... * 6 == one quad has 6 indices and we have resolution * resolution quads
            Console.WriteLine($"Indices size before Loop: {indices.Capacity}");

			uint vi = 0; // vertexIndex
            for (uint i = 0; i < vertices.Count; i += 6)
            {
				if ((vi + 1) % resolution == 0)
				{
					vi++;
					continue;
				}

				indices.AddRange([vi, vi+1, vi+1+resolution, 
								  vi, vi+1+resolution, vi+resolution]);
				vi++;
            }

            Console.WriteLine($"Indices size after Loop: {indices.Count}");

            return (vertices.ToArray(), []);
		}

		// https://youtu.be/QN39W020LqU?si=a66D1Lnic1vNaC6l&t=89
		// https://github.com/SebLague/Procedural-Planets/blob/master/Procedural%20Planet%20E01/Assets/TerrainFace.cs
		/// <param name="localUp">The unit vector in which the side should point. E.g. Vector.UnitX</param>
		public Mesh GetFace(Vector3D<float> localUp)
		{
			// this all probably needs to be rewritten to use the "Face" record below and split the stuff better
			return new Mesh();
		}
	}

	internal record struct Face
	{
		public Face()
		{

		}
	}
}
